# Interface methods for submodule: ImageBase
from typing import Union, Any
# additional imports
from .support.template_class import itkTemplate as _itkTemplate
from ._proxies import DataObjectProxy as _DataObjectProxy


# Interface methods for class: ImageBase
class ImageBaseProxy(_DataObjectProxy):
	@staticmethod
	def New():
		""""""
		...

	def Clone(self):
		""""""
		...

	def GetNameOfClass(self):
		""""""
		...

	def Initialize(self) -> None:
		""""""
		...

	@staticmethod
	def GetImageDimension() -> int:
		""""""
		...

	@overload
	def SetOrigin(self, _arg: Sequence[float]) -> None:
		""""""
		...

	@overload
	def SetOrigin(self, origin) -> None:
		""""""
		...

	def SetDirection(self, direction) -> None:
		""""""
		...

	def GetDirection(self):
		""""""
		...

	def GetInverseDirection(self):
		""""""
		...

	def GetSpacing(self) -> Sequence[float]:
		""""""
		...

	def GetOrigin(self) -> Sequence[float]:
		""""""
		...

	def Allocate(self, initialize: bool = False) -> None:
		""""""
		...

	def AllocateInitialized(self) -> None:
		""""""
		...

	def SetLargestPossibleRegion(self, region: ImageRegion) -> None:
		""""""
		...

	def GetLargestPossibleRegion(self) -> ImageRegion:
		""""""
		...

	def SetBufferedRegion(self, region: ImageRegion) -> None:
		""""""
		...

	def GetBufferedRegion(self) -> ImageRegion:
		""""""
		...

	@overload
	def SetRequestedRegion(self, region: ImageRegion) -> None:
		""""""
		...

	@overload
	def SetRequestedRegion(self, data) -> None:
		""""""
		...

	def GetRequestedRegion(self) -> ImageRegion:
		""""""
		...

	@overload
	def SetRegions(self, region: ImageRegion) -> None:
		""""""
		...

	@overload
	def SetRegions(self, size: Sequence[int]) -> None:
		""""""
		...

	def GetOffsetTable(self):
		""""""
		...

	def ComputeOffset(self, ind: Sequence[int]) -> int:
		""""""
		...

	def ComputeIndex(self, offset: int) -> Sequence[int]:
		""""""
		...

	@overload
	def SetSpacing(self, spacing: Sequence[float]) -> None:
		""""""
		...

	@overload
	def SetSpacing(self, spacing) -> None:
		""""""
		...

	def CopyInformation(self, data) -> None:
		""""""
		...

	def Graft(self, image) -> None:
		""""""
		...

	def UpdateOutputInformation(self) -> None:
		""""""
		...

	def UpdateOutputData(self) -> None:
		""""""
		...

	def SetRequestedRegionToLargestPossibleRegion(self) -> None:
		""""""
		...

	def RequestedRegionIsOutsideOfTheBufferedRegion(self) -> bool:
		""""""
		...

	def VerifyRequestedRegion(self) -> bool:
		""""""
		...

	def IsCongruentImageGeometry(self, otherImage, coordinateTolerance: float, directionTolerance: float) -> bool:
		""""""
		...

	def IsSameImageGeometryAs(self, otherImage, coordinateTolerance: float = ..., directionTolerance: float = ...) -> bool:
		""""""
		...

	def GetNumberOfComponentsPerPixel(self) -> int:
		""""""
		...

	def SetNumberOfComponentsPerPixel(self, arg0: int) -> None:
		""""""
		...

